import 'package:flutter/material.dart';

import 'bootstrap_colors.dart';

class BootstrapInputDecoration extends InputDecoration {
  const BootstrapInputDecoration({
    Widget icon,
    String labelText,
    TextStyle labelStyle,
    String helperText,
    int helperMaxLines,
    String hintText,
    int hintMaxLines,
    String errorText,
    TextStyle errorStyle,
    int errorMaxLines,
    FloatingLabelBehavior floatingLabelBehavior = FloatingLabelBehavior.auto,
    bool isDense,
    EdgeInsetsGeometry contentPadding,
    bool isCollapsed = false,
    Widget prefixIcon,
    BoxConstraints prefixIconConstraints,
    Widget prefix,
    String prefixText,
    TextStyle prefixStyle,
    Widget suffixIcon,
    Widget suffix,
    String suffixText,
    TextStyle suffixStyle,
    BoxConstraints suffixIconConstraints,
    String counterText,
    Widget counter,
    TextStyle counterStyle,
    Color fillColor,
    Color focusColor,
    Color hoverColor,
    InputBorder errorBorder,
    InputBorder focusedErrorBorder,
    InputBorder disabledBorder,
    InputBorder enabledBorder,
    bool enabled = true,
    String semanticCounterText,
    bool alignLabelWithHint,
  }) : super(
          icon: icon,
          labelText: labelText,
          labelStyle: labelStyle,
          helperText: helperText,
          helperStyle: const TextStyle(
            fontSize: 14,
            color: BootstrapColors.textFormFieldHelperText,
          ),
          helperMaxLines: helperMaxLines,
          hintText: hintText,
          hintStyle: const TextStyle(
            fontSize: 14,
            color: BootstrapColors.textFormFieldHintText,
          ),
          hintMaxLines: hintMaxLines,
          errorText: errorText,
          errorStyle: errorStyle,
          errorMaxLines: errorMaxLines,
          floatingLabelBehavior: floatingLabelBehavior,
          isDense: isDense,
          contentPadding: contentPadding,
          isCollapsed: isCollapsed,
          prefixIcon: prefixIcon,
          prefixIconConstraints: prefixIconConstraints,
          prefix: prefix,
          prefixText: prefixText,
          prefixStyle: prefixStyle,
          suffixIcon: suffixIcon,
          suffix: suffix,
          suffixText: suffixText,
          suffixStyle: suffixStyle,
          suffixIconConstraints: suffixIconConstraints,
          counterText: counterText,
          counter: counter,
          counterStyle: counterStyle,
          filled: enabled ? null : true,
          fillColor: enabled ? null : BootstrapColors.grayLighter,
          focusColor: focusColor,
          hoverColor: hoverColor,
          errorBorder: errorBorder,
          focusedBorder: const OutlineInputBorder(
            borderSide: BorderSide(
              color: BootstrapColors.textFormFieldBorder,
            ),
          ),
          focusedErrorBorder: focusedErrorBorder,
          disabledBorder: disabledBorder,
          enabledBorder: enabledBorder,
          border: const OutlineInputBorder(
            borderSide: BorderSide(
              color: BootstrapColors.textFormFieldBorder,
            ),
          ),
          enabled: enabled,
          semanticCounterText: semanticCounterText,
          alignLabelWithHint: alignLabelWithHint,
        );
}
